Robotsystem of the Robot Group Leipzig: OdeRobot Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Examples

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# OdeRobot Class Reference

Abstract class for ODE robots. More...

`#include <oderobot.h>`

Inherits AbstractRobot.

Inherited by Arm2Segm, Component, DefaultCaterPillar, DefaultSliderWheelie, DefaultWheelie, ForcedSphere, Formel1, HurlingSnake, MuscledArm, Nimm2, Nimm4, Schlange, ShortCircuit, Sphererobot, Sphererobot3Masses, TruckMesh, and Uwo.

Inheritance diagram for OdeRobot:

[legend]
Collaboration diagram for OdeRobot:

[legend]
List of all members.

## Public Member Functions
| OdeRobot (const OdeHandle &odeHandle, const OsgHandle &osgHandle, const std::string &name, const std::string &revision)
| Constructor.
virtual | ~OdeRobot ()
virtual void | update ()=0
| update the OSG notes here
virtual void | place (const Pos &pos)
| sets the vehicle to position pos pos desired position of the robot
virtual void | place (const osg::Matrix &pose)=0
| sets the pose of the vehicle
virtual bool | collisionCallback (void *data, dGeomID o1, dGeomID o2)=0
| checks for internal collisions and treats them.
virtual void | doInternalStuff (const GlobalData &globalData)=0
| this function is called in each timestep.
virtual void | setColor (const Color &col)
| sets color of the robot
virtual Position | getPosition () const
| returns position of the object
virtual Position | getSpeed () const
| returns linear speed vector of the object
virtual matrix::Matrix | getOrientation () const
| returns the orientation of the object
virtual Primitive * | getMainPrimitive () const =0
| overload this in the robot implementation.
## Static Protected Member Functions
static bool | isGeomInPrimitiveList (Primitive **ps, int len, dGeomID geom)
static bool | isGeomInPrimitiveList (std::list< Primitive * > ps, dGeomID geom)
static matrix::Matrix | odeRto3x3RotationMatrixT (const double R[12])
static matrix::Matrix | odeRto3x3RotationMatrix (const double R[12])
## Protected Attributes
OdeHandle | odeHandle
OsgHandle | osgHandle
dSpaceID | parentspace
## Friends
class | OdeAgent

## Detailed Description

Abstract class for ODE robots.

## Constructor & Destructor Documentation

OdeRobot | ( | const OdeHandle & | odeHandle,
|  | const OsgHandle & | osgHandle,
|  | const std::string & | name,
|  | const std::string & | revision |
| ) |  |  |

Constructor.

Parameters:

  | odehandle | structure with all global ODE variables

~OdeRobot | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual bool collisionCallback | ( | void * | data,
|  | dGeomID | o1,
|  | dGeomID | o2 |
| ) |  |  | `[pure virtual]`

checks for internal collisions and treats them.

In case of a treatment return true (collision will be ignored by other objects and the default routine) else false (collision is passed to other objects and (if not treated) to the default routine).

Implemented in Arm2Segm, AtomComponent, Component, DefaultCaterPillar, DefaultSliderWheelie, DefaultWheelie, ForcedSphere, Formel1, HurlingSnake, MuscledArm, Nimm2, Nimm4, RobotComponent, Schlange, ShortCircuit, SimpleComponent, Sphererobot, Sphererobot3Masses, TruckMesh, and Uwo.

virtual void doInternalStuff | ( | const GlobalData & | globalData | ) | `[pure virtual]`

this function is called in each timestep.

It should perform robot-internal checks, like space-internal collision detection, sensor resets/update etc.

Parameters:

  | globalData | structure that contains global data from the simulation environment

Implemented in Arm2Segm, AtomComponent, Component, DefaultCaterPillar, DefaultSliderWheelie, DefaultWheelie, ForcedSphere, Formel1, HurlingSnake, MuscledArm, Nimm2, Nimm4, RobotComponent, Schlange, ShortCircuit, SimpleComponent, Sphererobot, Sphererobot3Masses, TruckMesh, and Uwo.

virtual Primitive* getMainPrimitive | ( |  | ) | const`[pure virtual]`

overload this in the robot implementation.

If there is no object for some reason then return a null pointer

Returns:
  main object of the robot (used for tracking)

Implemented in Arm2Segm, AtomComponent, Component, DefaultCaterPillar, DefaultSliderWheelie, DefaultWheelie, ForcedSphere, Formel1, HurlingSnake, MuscledArm, Nimm2, Nimm4, PrimitiveComponent, RobotComponent, Schlange, ShortCircuit, SimpleComponent, Sphererobot, Sphererobot3Masses, TruckMesh, and Uwo.

matrix::Matrix getOrientation | ( |  | ) | const`[virtual]`

returns the orientation of the object

Returns:
  3x3 rotation matrix

Implements Trackable.

Position getPosition | ( |  | ) | const`[virtual]`

returns position of the object

Returns:
  vector of position (x,y,z)

Implements Trackable.

Reimplemented in AtomComponent, Component, PrimitiveComponent, RobotComponent, and SimpleComponent.

Position getSpeed | ( |  | ) | const`[virtual]`

returns linear speed vector of the object

Returns:
  vector (vx,vy,vz)

Implements Trackable.

static bool isGeomInPrimitiveList | ( | std::list< Primitive * > | ps,
|  | dGeomID | geom |
| ) |  |  | `[static, protected]`

bool isGeomInPrimitiveList | ( | Primitive ** | ps,
|  | int | len,
|  | dGeomID | geom |
| ) |  |  | `[static, protected]`

matrix::Matrix odeRto3x3RotationMatrix | ( | const double | R[12] | ) | `[static, protected]`

matrix::Matrix odeRto3x3RotationMatrixT | ( | const double | R[12] | ) | `[static, protected]`

virtual void place | ( | const osg::Matrix & | pose | ) | `[pure virtual]`

sets the pose of the vehicle

Parameters:

  | pose | desired 4x4 pose matrix

Implemented in Arm2Segm, AtomComponent, DefaultCaterPillar, DefaultSliderWheelie, DefaultWheelie, ForcedSphere, Formel1, HurlingSnake, MuscledArm, Nimm2, Nimm4, RobotComponent, Schlange, ShortCircuit, SimpleComponent, Sphererobot, Sphererobot3Masses, TruckMesh, and Uwo.

void place | ( | const Pos & | pos | ) | `[virtual]`

sets the vehicle to position pos pos desired position of the robot

Parameters:

  | pos | desired position of the robot

Reimplemented in AtomComponent, Component, PrimitiveComponent, RobotComponent, and SimpleComponent.

void setColor | ( | const Color & | col | ) | `[virtual]`

sets color of the robot

Parameters:

  | col | Color struct with desired Color

virtual void update | ( |  | ) | `[pure virtual]`

update the OSG notes here

Implemented in Arm2Segm, AtomComponent, Component, DefaultCaterPillar, DefaultSliderWheelie, DefaultWheelie, ForcedSphere, Formel1, HurlingSnake, MuscledArm, Nimm2, Nimm4, PrimitiveComponent, RobotComponent, Schlange, ShortCircuit, SimpleComponent, Sphererobot, Sphererobot3Masses, TruckMesh, and Uwo.

## Friends And Related Function Documentation

friend class OdeAgent`[friend]`

## Member Data Documentation

OdeHandle odeHandle`[protected]`

OsgHandle osgHandle`[protected]`

dSpaceID parentspace`[protected]`

Reimplemented in Arm2Segm, and MuscledArm.

The documentation for this class was generated from the following files:

- oderobot.h
- oderobot.cpp